【3.7】python异常处理

        在N多个数据一起处理的时候,如果某一个数据处理过程中出现了问题,那么我又不希望其他的停止,这个时候就需要异常处理

一、 出现异常

re = iter(range(5))
for i in range(100):
 print re.next()
print 'HaHaHaHa'

首先,我们定义了一个循环对象re,该循环对象将进行5次循环,每次使用序列的一个元素。 在随后的for循环中,我们手工调用next()函数。当循环进行到第6次的时候,re.next()不会再返回元素,而是抛出(raise)StopIteration的异常。整个程序将会中断。

二、 捕获错误信息

1使用try和except语句来捕获异常

try: 
     block 
except [exception,[data…]]: 
     block


try: 
     block 
except [exception,[data...]]: 
     block 
else: 
     block 

try: 
     f = open(“file.txt”,”r”) 
except IOError, e: 
     print e

Python异常处理有很强大处理能力,把错信息的显示给客户,在Python异常处理中,可以对其运行操作,下面是我们是对Python异常处理进行的一个详细的介绍,希望大家有所收获。

2使用try和except语句来捕获异常

try: 
     block 
except [exception,[data…]]: 
     block 

try: 
     block 
except [exception,[data...]]: 
     block 
else: 
     block 

捕获到的IOError错误的详细原因会被放置在对象e中,然后运行该python 异常处理的except代码块捕获所有的异常

3. 用raise语句手工引发一个异常:

raise [exception[,data]] 

try: 
     raise MyError #自己抛出一个异常 
except MyError: 
 print 'a error' 

raise ValueError,’invalid argument’ 

4. 采用sys模块回溯最后的异常

import sys 
try: 
 block 
except: 
 info=sys.exc_info() 
 print info[0],":",info[1]

5. python 异常处理的一些其它用途

下面的例子演示了如何使用异常支持特定平台功能。代码来自 getpass 模块,一个从用户获得口令的封装模块。获得口令在 UNIX、Windows 和 Mac OS 平台上的实现是不同的,但是这个代码封装了所有的不同之处。。

三 try/except详解

我们可以修改以上异常程序,直到完美的没有bug。但另一方面,如果我们在写程序的时候,知道这里可能犯错以及可能的犯错类型,我们可以针对该异常类型定义好”应急预案“。

re = iter(range(5))
try:
    for i in range(100):
        print re.next()
except StopIteration:
    print 'here is end ',i
print 'HaHaHaHa'

在try程序段中,我们放入容易犯错的部分。我们可以跟上except,来说明如果在try部分的语句发生StopIteration时,程序该做的事情。如果没有发生异常,则except部分被跳过。

随后,程序将继续运行,而不是彻底中断。

完整的语法结构如下:

try:
 ...
except exception1:
 ...
except exception2:
 ...
except:
 ...
else:
 ...
finally:
...

如果try中有异常发生时,将执行异常的归属,执行except。异常层层比较,看是否是exception1, exception2…,直到找到其归属,执行相应的except中的语句。如果except后面没有任何参数,那么表示所有的exception都交给这段程序处理。比如:

try:
 print(a*2)
except TypeError:
 print("TypeError")
except:
 print("Not Type Error & Error noted")

由于a没有定义,所以是NameError。异常最终被except:部分的程序捕捉。

如果无法将异常交给合适的对象,异常将继续向上层抛出,直到被捕捉或者造成主程序报错。比如下面的程序

def test_func():
    try:
        m = 1/0
    except NameError:
        print("Catch NameError in the sub-function")

try:
    test_func()
except ZeroDivisionError:
    print("Catch error in the main program")

子程序的try…except…结构无法处理相应的除以0的错误,所以错误被抛给上层的主程序。 如果try中没有异常,那么except部分将跳过,执行else中的语句。

finally是无论是否有异常,最后都要做的一些事情。

流程如下,

try->异常->except->finally
try->无异常->else->finally

四 、抛出异常

我们也可以自己写一个抛出异常的例子:

print 'Lalala'
raise StopIteration
print 'Hahaha'

这个例子不具备任何实际意义。只是为了说明raise语句的作用。

StopIteration是一个类。抛出异常时,会自动有一个中间环节,就是生成StopIteration的一个对象。Python实际上抛出的,是这个对象。当然,也可以自行生成对象:

raise StopIteration()

五 、for循环中引物异常处理

for k1 in range(len(multiple_rs)):
    try:
        rs_primers(work_time, multiple_rs[k1])
    except Exception, e:
        print e.message
        continue

要想循环继续下去,这个except中必须加continue

参考资料:

http://www.cnblogs.com/vamei/archive/2012/07/10/2582787.html

http://developer.51cto.com/art/201003/187933.htm

个人公众号,比较懒,很少更新,可以在上面提问题:

更多精彩,请移步公众号阅读:

Sam avatar
About Sam
专注生物信息 专注转化医学